#include <stdio.h>
#include <stdbool.h>
#include <math.h>
#include "arduino.h"
#include "request.h"
#include "uss.h"
#include "run.h"

int run(int dist_tl){// dist_tl 鋗 
int i=1;
int right=0;
int left=0;
double angle;
int uss_r[10000];
int uss_l[10000];
int speed,dist;
 uss_r[0] = uss_get_r();
 uss_l[0] = uss_get_l();
 command_data_t command_data;
 run_state_t state;
 
 if (arduino_open() != 0) return -1;
 if (uss_open_l() != 0) return -1;
 if (uss_open_r() != 0) return -1;
 
 
//  int dist_tl=360; 鋗

 while(1){
        


    uss_r[i] = uss_get_r();
    uss_l[i] = uss_get_l();
    
    if(i>=5){
        if(uss_r[i]<=uss_l[i]){
        if(uss_r[i] - uss_r[i-1] > 0){ // ɏQ (5bOƒZT̒lׂ)
        right++;
        left=0;
        printf("right%d\n",right);
        }else if(uss_r[i] - uss_r[i-1] < 0){
        left++;
        right=0;
        printf("left%d\n",left);
        }
    	printf("%d",uss_r[i]);
        }else{
        if(uss_l[i] - uss_l[i-1] < 0){ // ɏQ (5bOƒZT̒lׂ)
        right++;
        left=0;
        printf("right%d\n",right);
        }else if(uss_l[i] - uss_l[i-1] > 0){
        left++;
        right=0;
        printf("left%d\n",left);
        }
    	printf("%d",uss_l[i]);
        }
    	}
        arduino_receive(&command_data);
        request_get_runmode(&state,&speed,&dist);

        if(right>=5 || left>=5){
            if(uss_r[i]<=uss_l[i]){
                angle = 360*(asin((double)(uss_r[i-5]-uss_r[i])/180))/6.14;
            }else {
                angle = -360*(asin((double)(uss_l[i-5]-uss_l[i])/180))/6.14; 
            }
            right=0;
            left=0;
            printf("ispxC %lf,\n",angle);   
            request_set_runmode(ROT, 110, angle);
            //anglȇ傫ɂĐispxCI
        }else if(state!=STR) {
            request_set_runmode(STR,40,dist_tl);
	}
	dist_tl= dist_tl - speed*0.9;
        if(dist_tl<=0){
          break;
    }
        if(i>=10000){
            i=5;
            uss_r[0]=uss_r[i-4];
            uss_r[1]=uss_r[i-3];
            uss_r[2]=uss_r[i-2];
            uss_r[3]=uss_r[i-1];
            uss_r[4]=uss_r[i];
        }
	i++;
	usleep(1000 * 900);
}
}
